//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  callbacks.cpp: events callbacks
//--------------------------------------------------------------------------//

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <iostream>

#include "callbacks.h"
#include "support.h"
#include "gmodapp.h"

using namespace gmodcfg;

extern Application* TheApp;

//--------------------------------------------------------------------------//
//  "File" menu handlers
//--------------------------------------------------------------------------//
void
on_save1_activate( GtkMenuItem* menuitem, gpointer user_data )
{
    TheApp->SaveAllOptions();
}

void
on_quit1_activate( GtkMenuItem* menuitem, gpointer user_data )
{
    TheApp->Quit();
}

//--------------------------------------------------------------------------//
//  "Edit" menu handlers
//--------------------------------------------------------------------------//
void
on_preferences1_activate( GtkMenuItem* menuitem, gpointer user_data )
{
    // TODO
}

//--------------------------------------------------------------------------//
//  "Install" menu handlers
//--------------------------------------------------------------------------//
void
on_install_a_module_activate( GtkMenuItem* menuitem, gpointer user_data )
{
    TheApp->InstallPackage();
}

void
on_uninstall_a_module_activate( GtkMenuItem* menuitem, gpointer user_data )
{
    TheApp->UnInstallPackage();
}

//--------------------------------------------------------------------------//
//  "Help" menu handlers
//--------------------------------------------------------------------------//
void
on_about1_activate( GtkMenuItem* menuitem, gpointer user_data )
{
    TheApp->ShowAboutBox();
}

//--------------------------------------------------------------------------//
//  "Search" handlers
//--------------------------------------------------------------------------//
void
on_search_combo_entry_changed( GtkEditable* editable, gpointer )
{
    const gchar* modName = gtk_entry_get_text( GTK_ENTRY(editable) );
    if ( TheApp->BuildModuleGui( modName ) )
        TheApp->AddToSearchHistory( modName );
}

//--------------------------------------------------------------------------//
//  "Quit dialog" handlers
//--------------------------------------------------------------------------//
void
on_quitdialog_savebutton_clicked( GtkButton* button, gpointer user_data )
{
    TheApp->SaveAllOptions();
    gtk_main_quit();
}

void
on_quitdialog_dontsavebutton_clicked( GtkButton* button, gpointer user_data )
{
    gtk_main_quit();
}

