//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  dkmsinstallmgr.h: DKMS installation manager
//--------------------------------------------------------------------------//

#ifndef dkmsinstallmgr_h
#define dkmsinstallmgr_h

#include "installmgr.h"
#include <gnome.h>

namespace gmodcfg {

class DkmsInstallManager : public InstallManager
{
    public:
        explicit DkmsInstallManager( int verbosity=0 );
        ~DkmsInstallManager() {}

    private:
        bool installPackage( const string& pkgFileName );
        bool uninstallPackage( const string& pkgName );
        bool isPackageInstalled( const string& pkgName ) const;
};

};

#endif
