//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  gmodapp.h: main application' interface
//--------------------------------------------------------------------------//

#ifndef gmodapp_h
#define gmodapp_h

#include <gnome.h>
#include <string>
#include <set>
using std::string;

namespace gmodcfg {

class Module;

class Application
{
        typedef std::set<string> SetString_t;
		GtkWidget* TopWidget;
		GtkTreeView* TreeView;
        SetString_t ModulesNames;
        GnomeAppBar* StatusBar;
        GnomeEntry* SearchEntry;
        SetString_t History;
        string ModulesConfFile, ModulesPath;
        int Verbosity;

        GtkWidget* ModuleManagerWidget;
        bool loadControl( GtkBox* );

        Application( const Application& );
        Application& operator=( const Application& );

	public:
		Application( const string& modpath, const string& modConfFile,
                     int verbosity=0 );
        ~Application() {}

		void Start();
        void Quit();

        // main GUI actions
        bool BuildModuleGui( const char* );
        void AddToSearchHistory( const char* );
        void SaveAllOptions();
        void InstallPackage();
        void UnInstallPackage();
        void ShowAboutBox() const;
};

};

#endif
