//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  gmodeditapp.h: gmodconfig-edit's application interface
//--------------------------------------------------------------------------//

#ifndef gmodeditapp_h
#define gmodeditapp_h

#include <gnome.h>
#include <string>
using std::string;

namespace gmodcfg {

class XsaManager;
class ModuleXmlManager;

class EditorApplication
{
		GtkWidget* TopWidget;
        XsaManager* XsaMgr;
        ModuleXmlManager* ModXmlMgr;
        GtkEntry* XsaFileEntry, *ModuleFileEntry;
        int Verbosity;

        void startModXmlMgr();
        void startXsaMgr();

        EditorApplication( const EditorApplication& );
        EditorApplication& operator=( const EditorApplication& );

	public:
		explicit EditorApplication( int verbosity = 0 );
        ~EditorApplication();

        XsaManager* GetXsaMgr() const { return XsaMgr; }
        ModuleXmlManager* GetModXmlMgr() const { return ModXmlMgr; }
        void Quit();

        // XSA stuff
        void NewXsa();
        void LoadXsa();
        void CloseXsaDruid();

        // Module info stuff
        void NewModuleInfo();
        void LoadModuleInfo();
        void CloseModXmlDruid();
};

};

#endif
