//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  modxmlmgr.h: Module XML assistant
//--------------------------------------------------------------------------//

#ifndef modxmlmgr_h
#define modxmlmgr_h

#include <gnome.h>
#include <string>
using std::string;

namespace gmodcfg {

class Module;
class ParamTreeViewManager;

class ModuleXmlManager
{
        GtkWidget* Assistant;
        GnomeDruid* Druid;
        GnomeAppBar* StatusBar;
        Module *ModuleXmlInfos, *ModuleModinfos;
        string ModuleXmlFileName;
        int Verbosity;
        ParamTreeViewManager* TreeViewMgr;
		GtkTreeView* TreeView;

        GtkWidget* ModinfoButton;
        GtkEntry *ModNameEntry, *ModUrlEntry, *ModXsaEntry, *ModUsageEntry;
        GtkTextView *ModUsageModinfoTextView, *ModAboutTextView;
        GtkLabel* ParamNameLabel;
        GtkEntry *ParamTypeEntry, *ParamValuesEntry, *ParamDefaultEntry,
                 *ParamMinEntry, *ParamMaxEntry;
        GtkTextView *ParamModinfoTextView, *ParamDescTextView;
        bool Initialized;

        ModuleXmlManager( const ModuleXmlManager& );
        ModuleXmlManager& operator=( const ModuleXmlManager& );

        void cleanUp();
        void initDruid();
        void populateDruid();

	public:
		explicit ModuleXmlManager( GtkWidget* appWidget, int verbosity=0 );
        ~ModuleXmlManager();

        GtkWidget* GetDruidWindow() const { return Assistant; }

        // Interface: start/stop the assistant
        void StartNew( const string& fileName );
        bool OpenModuleXml( const string& fileName );
        void SaveXmlFile();

        // callbacks
        void HeaderModinfoButtonHandler();
        void ParamDeleteButtonHandler();
        void ParamUpButtonHandler();
        void ParamDownButtonHandler();
        void ParamAddButtonHandler();
        void ParamApplyButtonHandler();
        void ParamClearButtonHandler();
        void ParamTypeChanged();
};

};

#endif
