//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  treeviewmgr.h: a class to manage a GtkTreeView
//--------------------------------------------------------------------------//

#ifndef treeviewmgr_h
#define treeviewmgr_h

#include <gnome.h>

namespace gmodcfg 
{

class TreeViewManager
{
    protected:
        GtkListStore* ListStore;
        GtkTreeView* TreeView;

    public:
        explicit TreeViewManager( GtkTreeView* );
        virtual ~TreeViewManager() {}

        void InitListStore();

        void AddEntry();
        void DeleteSelectedEntry();
        void UpdateSelectedEntry();
        void MoveSelectedEntryUp();
        void MoveSelectedEntryDown();

        GtkListStore* GetListStore() const { return ListStore; }

    private:
        virtual void createListStore() = 0;
        virtual void initTreeView() = 0;
        virtual void moveListItem( GtkTreeIter* from, GtkTreeIter* to ) = 0;
        virtual void setListEntry( GtkTreeIter* ) = 0;
};

};

#endif
