//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  xsamgr.h: XSA assistant
//--------------------------------------------------------------------------//

#ifndef xsamgr_h
#define xsamgr_h

#include <gnome.h>
#include <string>

namespace gmodcfg {

class XsaData;
class XsaTreeViewManager;

class XsaManager
{
        GtkWidget* Assistant;
        GnomeDruid* Druid;
        GnomeAppBar* StatusBar;
        XsaData* XsaStuff;
        std::string XsaFileName;
        int Verbosity;
        XsaTreeViewManager* TreeViewMgr;
		GtkTreeView* TreeView;
        GtkEntry *AuthorNameEntry, *AuthorEmailEntry, *AuthorUrlEntry;
        GtkEntry *ProdIdEntry, *ProdNameEntry, *ProdVersionEntry,
                 *ProdUrlEntry, *ProdChangesEntry, *ProdFileEntry;
        GnomeDateEdit* ProdLastRelEntry;

        XsaManager( const XsaManager& );
        XsaManager& operator=( const XsaManager& );

        void initDruid();
        void initAuthorPage();
        void initProductsPage();

	public:
		explicit XsaManager( GtkWidget* appWidget, int verbosity=0 );
        ~XsaManager();

        GtkWidget* GetDruidWindow() const { return Assistant; }

        // Interface: start/stop the XSA assistant
        void StartNew( const std::string& fileName );
        bool OpenXsa( const std::string& fileName );
        void SaveXsaFile();

        // callbacks
        void ProductsDeleteButtonHandler();
        void ProductsUpButtonHandler();
        void ProductsDownButtonHandler();
        void ProductsAddButtonHandler();
        void ProductsApplyButtonHandler();
        void ProductsClearButtonHandler();
};

};

#endif
