//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  xsatypes.cpp: XsaData class
//--------------------------------------------------------------------------//

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "xsatypes.h"
#include <algorithm>

using namespace gmodcfg;

//--------------------------------------------------------------------------//
//  XsaData
//--------------------------------------------------------------------------//
XsaData::~XsaData()
{
    ClearProducts();
}

//--------------------------------------------------------------------------//
//  Add a product. no unicity checks are done
//--------------------------------------------------------------------------//
void
XsaData::AddProduct( const string& id_, const string& name_,
                     const string& ver_, const string& rel_,
                     const string& url_, const string& changes_,
                     const string& file_ )
{
    // TODO: modify date format
    XsaData::Product* p =
        new XsaData::Product( id_, name_, ver_, rel_, url_, changes_, file_ );
    Products.push_back( p );
}

//--------------------------------------------------------------------------//
//  Deletes all products
//--------------------------------------------------------------------------//
struct deleteProductFunctor
{
    void operator()( const XsaData::Product* p ) const { delete p; }
};

void
XsaData::ClearProducts()
{
    std::for_each( Products.begin(), Products.end(), deleteProductFunctor() );
    Products.clear();
}

